var bindforconsole = "";
var radiocom = "";
var space = ' ';
var newline = " \n";
var fus = '"'
var newtext = "";
var sayv = "";

var bindedKeys = {};

keyCodeToQKey = {
    49: "1",
    50: "2",
}


keyToQKey = {
    "esc":          "TESTINGTHIS",
    "f1":           "f1",
    "f2":           "f2",
    "f3":           "f3",
    "f4":           "f4",
    "f5":           "f5",
    "f6":           "f6",
    "f7":           "f7",
    "f8":           "f8",
    "f9":           "f9",
    "f10":          "f10",
    "f11":          "f11",
    "f12":          "f12",
    "n1":           "1",
    "n2":           "2",
    "n3":           "3",
    "n4":           "4",
    "n5":           "5",
    "n6":           "6",
    "n7":           "7",
    "n8":           "8",
    "n9":           "9",
    "n0":           "0",
    "num0":         "KP_INS",
    "numnum":       "KP_NUMLOCK",
    "numsl":        "KP_SLASH",
    "numst":        "KP_STAR",
    "num7":         "KP_HOME",
    "num8":         "KP_UPARROW",
    "num9":         "KP_PGUP",
    "numpl":        "KP_PLUS",
    "num4":         "KP_LEFTARROW",
    "num5":         "KP_5",
    "num6":         "KP_RIGHTARROW",
    "num1":         "KP_END",
    "num2":         "KP_DOWNARROW",
    "num3":         "KP_PGDN",
    "numen":        "KP_ENTER",
    "tab":          "TAB",
    "q":            "q",
    "w":            "w",
    "e":            "e",
    "r":            "r",
    "t":            "t",
    "z":            "z",
    "u":            "u",
    "i":            "i",
    "o":            "o",
    "p":            "p",
    "plus":         "+",
    "lock":         "CAPSLOCK",
    "a":            "a",
    "s":            "s",
    "d":            "d",
    "f":            "f",
    "g":            "g",
    "h":            "h",
    "j":            "j",
    "k":            "k",
    "l":            "l",
    "ns":           "#",
    "sshift":       "SHIFT",
    "la":           "<",
    "y":            "y",
    "x":            "x",
    "c":            "c",
    "v":            "v",
    "b":            "b",
    "n":            "n",
    "m":            "m",
    "komma":        ",",
    "dot":          ".",
    "minus":        "-",
    "uparrow":      "UPARROW",
    "downarrow":    "DOWNARROW",
    "leftarrow":    "LEFTARROW",
    "rightarrow":   "RIGHTARROW",
    "ctrl":         "CTRL",
    "sspace":       "SPACE",
    "aalt":         "ALT",
    "del":          "KP_DEL",
    "num0":         "KP_INS",
}
/*
document.addEventListener('keydown', function(event) {
    console.log('event.keyCode: ' + event.keyCode + ' event.which: ' + event.which);
}, true);
*/
$(document).ready(function(){
    $('.keyButton').click(function(){
        activated = $('.keyActive');
        if ($(this) != activated) {
            activated.toggleClass('keyActive');
            $(this).toggleClass('keyActive');
            if (typeof bindedKeys[$(this).val()] != 'undefined') {
                loadKey($(this).val());
            } else {
                $('.keyEditorForm')[0].reset();
            }
        }
    });
})

function clearConsoleText() {
    document.bindform.consoletext.value = '';
}

function bindKey() {
    var activeKey = $('.keyActive');
    if (activeKey.length == 0) {
        return;
    }
    activeKey.toggleClass('keyBinded',true);
    bindedKeys[activeKey.val()] = {
        'consoleString': 'bind ' + keyToQKey[activeKey.val()] + ' "' + $('.keyEditor select[name="radioSelectName"]').val() + ' ' + $('.keyEditor textarea[name="radioTextName"]').val() + '"' + '\n',
        'textarea[name="radioTextName"]': $('.keyEditor textarea[name="radioTextName"]').val(),
        'select[name="radioSelectName"]': $('.keyEditor select[name="radioSelectName"]').val()
    };
    consoleRefresh();
}

function unbindKey() {
    var activeKey = $('.keyActive');
    if (activeKey.length == 0) return;
    if (typeof bindedKeys[activeKey.val()] == 'undefined') return;
    activeKey.toggleClass('keyBinded',false);
    delete bindedKeys[activeKey.val()];
    $('.keyEditorForm')[0].reset();
    consoleRefresh();
}

function loadKey( keyVal ) {
    for (var prop in bindedKeys[keyVal]) {
        $('.keyEditor ' + prop).val(bindedKeys[keyVal][prop]);
    }
}

function consoleRefresh() {
    consoleOutput = $('#consoleOutputId')[0];
    consoleOutput.value = '';
    for (var keyBind in bindedKeys) {
        consoleOutput.value += bindedKeys[keyBind].consoleString;
    }
}

function colorSelect() {
    sayv = $('.keyEditor textarea[name="radioTextName"]').val();
    $('.keyEditor textarea[name="radioTextName"]').val(sayv + $('#colorSelectId').val());
}

var image_sizes = new Object();
var fovImg = new Object();
image_sizes[90] = [966, 546];
image_sizes[100] = [1140, 638];
image_sizes[110] = [1366, 768];

function make_fov_for_console() {
    if (($('#fov_enter').val() < 90) || ($('#fov_enter').val() > 110)) return;
    $('#fov_for_console')[0].value = "cg_fov " + $('#fov_enter').val();
    image_size = get_fov_image_size($('#fov_enter').val());
    image_width = image_size[0] * fovImg.scale;
    image_height = image_size[1] * fovImg.scale;
    wrapperEl = document.querySelector('.fov_wrapper');
    containerEl = document.querySelector('.fov_container');
    cutterEl = document.querySelector('.fov_cutter');
    fovToImgScale = (cutterEl.offsetWidth / image_width);
    image_width = fovImg.width * fovToImgScale;
    image_height = fovImg.height * fovToImgScale;
    wrapperEl.style.width = image_width + "px";
    wrapperEl.style.height = image_height + "px";
    wrapperEl.style.marginTop = ( parseInt(containerEl.style.height) - image_height ) / 2 + "px";
}

function get_fov_image_size(fov) {
    fov = parseInt(fov);
    for ( image_fov in image_sizes) {
        image_fov = parseInt(image_fov);
        image_size = image_sizes[image_fov];
        if (image_fov == fov) {
            return [image_size[0], image_size[1]];
        }
        if (image_fov > fov) {
            last_image_size = image_sizes[last_image_fov];
            width = last_image_size[0] + (image_size[0] - last_image_size[0]) / (image_fov - last_image_fov) * (fov - last_image_fov);
            height = last_image_size[1] + (image_size[1] - last_image_size[1]) / (image_fov - last_image_fov) * (fov - last_image_fov);
            return [width, height];
        }
        last_image_fov = image_fov;
    }
    //The fov is less than 90 or more than 110
    return [1366, 768];
}

window.onload = function (){
    imgEl = document.querySelector('.fov_cutter img');
    cutterEl = document.querySelector('.fov_cutter');
    containerEl = document.querySelector('.fov_container');
    wrapperEl = document.querySelector('.fov_wrapper');
    fovImg.scale = cutterEl.offsetWidth / image_sizes[90][0];
    fovImg.width = imgEl.offsetWidth * fovImg.scale;
    fovImg.height = imgEl.offsetHeight * fovImg.scale;
    cutterEl.style.height = fovImg.height / fovImg.width * cutterEl.offsetWidth + "px";
    imgEl.style.width = "100%";
    imgEl.style.height = "100%";
    containerEl.style.width = fovImg.width + "px";
    containerEl.style.height = fovImg.height + "px";
    containerEl.style.left = "-" + (fovImg.width - cutterEl.offsetWidth) / 2 + "px";
    containerEl.style.top = "-" + (fovImg.height - cutterEl.offsetHeight) / 2 + "px";
    wrapperEl.style.width = fovImg.width + "px";
    wrapperEl.style.height = fovImg.height + "px";
};